/*
 * LogEntryParser_LogfileLWI.h
 *
 *  Created on: Dec 18, 2011
 *      Author: sven
 */

#ifndef LogEntryParser_LogfileLWI_H_
#define LogEntryParser_LogfileLWI_H_
#include <QFile>
#include <QTextStream>
#include <QThread>

#include "LogData/LogEntryParser.h"

/**
 * This parser is used to read the previously generated log file. This file is
 * generated by the LogEntryTableModel using the exportToFile method.
 */
class LogEntryParser_LogfileLWI
: public QThread
//, public LogFileParser
, public LogEntryParser
{
    Q_OBJECT
public:
    LogEntryParser_LogfileLWI( const QString &filename );

    ~LogEntryParser_LogfileLWI() override;

    void startEmiting() override;

    void run() override;

    bool initParser() override;

    std::shared_ptr<LogEntryParserModelConfiguration> getParserModelConfiguration() const override;

signals:
    void newEntry(TconstSharedNewLogEntryMessage) override;

    void signalError(QString error) override;

    void finished() override;

private:

    TSharedLogEntry logEntryFromString( const QString &str);

    TSharedLogEntry getNextLogEntry();

    bool m_abort = false;

    QFile m_logfile;

    QTextStream m_logfileStream;

    bool m_logfileStreamReady = false;

    QString m_stashedLine;

    std::shared_ptr<LogEntryFactory> m_factory;

    std::shared_ptr<LogEntryParserModelConfiguration> m_myModelConfig;

    int m_logEntryNumber = 0;

    std::vector<int> m_order;
};

#endif /* LogEntryParser_LogfileLWI_H_ */
